#include <avr/io.h>
#include <stdio.h>
#include "uart.h"


FILE mystdout = FDEV_SETUP_STREAM(uart_putchar, NULL, _FDEV_SETUP_WRITE);

volatile uint8_t uart_str_complete;
volatile uint8_t uart_str_count;
volatile char uart_string[uart_maxstrlen+1]="";

///////////////////////////////////////////////////////////////////
//
//		Initialisierung des UARTS und konfiguration des Outputs
//
//////////////////////////////////////////////////////////////////

unsigned char rx_string[100];
int rx_index;

void usart1_init(void)
{
    UBRR1H = MYUBRR >> 8;
    UBRR1L = MYUBRR;
    UCSR1B = (1 <<RXCIE1)| (1<<RXEN1)|(1<<TXEN1);
	UCSR1C = (0<<UMSEL1) |(0<<UPM11) |(0<<UPM10) |(0<<USBS1)  | (1<<UCSZ11) |(1<<UCSZ10)| (0<<UCPOL1);
  	UCSR1A = (0<<RXC1)   |(0<<TXC1)   |(1<<UDRE1) |(0<<FE1)   |(0<<DOR1)   | (0<<UPE1)  | (0<<U2X1) |(0<<MPCM1);
    stdout = &mystdout; //Required for printf init
}

int uart_putchar(char c, FILE *stream)
{
    if (c == '\n') uart_putchar('\r', stream);

    loop_until_bit_is_set(UCSR1A, UDRE1);
    UDR1 = c;

    return 0;
}
